static const char *RcsId = "$Id $";
//+=============================================================================
//
// file :         Keithley428StateMachine.cpp
//
// description :  C++ source for the Keithley428 and its alowed 
//                methods for commands and attributes
//
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source:  $
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#include <tango.h>
#include <Keithley428.h>
#include <Keithley428Class.h>

/*====================================================================
 *	This file contains the methods to allow commands and attributes
 * read or write execution.
 *
 * If you wand to add your own code, add it between 
 * the "End/Re-Start of Generated Code" comments.
 *
 * If you want, you can also add your own methods.
 *====================================================================
 */

namespace Keithley428_ns
{

//=================================================
//		Attributes Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_Gain_allowed
// 
// description : 	Read/Write allowed for Gain attribute.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_Gain_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_GainStr_allowed
// 
// description : 	Read/Write allowed for GainStr attribute.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_GainStr_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_Overloaded_allowed
// 
// description : 	Read/Write allowed for Overloaded attribute.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_Overloaded_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_RiseTime_allowed
// 
// description : 	Read/Write allowed for RiseTime attribute.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_RiseTime_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_Bypass_allowed
// 
// description : 	Read/Write allowed for Bypass attribute.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_Bypass_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_filterState_allowed
// 
// description : 	Read/Write allowed for filterState attribute.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_filterState_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_autoFilterState_allowed
// 
// description : 	Read/Write allowed for autoFilterState attribute.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_autoFilterState_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_PerformZeroCorrect_allowed
// 
// description : 	Execution allowed for PerformZeroCorrect command.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_PerformZeroCorrect_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_FilterOn_allowed
// 
// description : 	Execution allowed for FilterOn command.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_FilterOn_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_FilterOff_allowed
// 
// description : 	Execution allowed for FilterOff command.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_FilterOff_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_AutoFilterOn_allowed
// 
// description : 	Execution allowed for AutoFilterOn command.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_AutoFilterOn_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley428::is_AutoFilterOff_allowed
// 
// description : 	Execution allowed for AutoFilterOff command.
//
//-----------------------------------------------------------------------------
bool Keithley428::is_AutoFilterOff_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}

}	// namespace Keithley428_ns
